#ifdef BGE_COCONUT
#include "shaders/common/postfx/hdr/ACES.h.hlsl"
#endif



float3 Tonemap_Lottes(float3 x) {
    // Lottes 2016, "Advanced Techniques and Optimization of HDR Color Pipelines"
    const float a = 1.6;
    const float d = 0.977;
    const float hdrMax = 8.0;
    const float midIn = 0.18;
    const float midOut = 0.267;

    // Can be precomputed
    const float b =
        (-pow(midIn, a) + pow(hdrMax, a) * midOut) /
        ((pow(hdrMax, a * d) - pow(midIn, a * d)) * midOut);
    const float c =
        (pow(hdrMax, a * d) * pow(midIn, a) - pow(hdrMax, a) * pow(midIn, a * d) * midOut) /
        ((pow(hdrMax, a * d) - pow(midIn, a * d)) * midOut);

    return pow(x, a) / (pow(x, a * d) * b + c);
}

//Credits for code below goes to Travarmojsije on the BeamNG forums, from his GT Sport tonemap

float3 Exp_Correction(float3 x)
{
    const float exp = 0.5;
    float3 corrected= x*exp;
    return Tonemap_Lottes(corrected);
}

float3 tonemap(float3 rgb) {
#ifdef BGE_COCONUT
    return toLinearColor(ACESFitted(linearToGammaColor(rgb)));
#else
   return Exp_Correction(rgb);
#endif
}
